//+------------------------------------------------------------------+
//|                                                 Z_MTF_RSI.mq4 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Z_MTF_RSI"
#property link      "Z_MTF_RSI"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 DodgerBlue //Lime //Yellow

#property indicator_level1 80 
#property indicator_level2 50 
#property indicator_level3 20 

#property indicator_maximum 100                     
#property indicator_minimum 0

extern int   TimeFrame     = 60;//0
extern int   RSIperiod     = 5;//14 <<<<<<<<<<<<<<<<<<<<<<<<<<<<
extern int   applied_price = 0;
extern bool  RSI_Script    = true;
extern int   In_Window     = 3;//1
extern int   LineSize      = 2;//1
extern int   CountBars     = 500;//1000


double RSIBuffer[];
double PosBuffer[];
double NegBuffer[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

//---- indicators
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,LineSize);
   SetIndexBuffer(0,RSIBuffer);

  
//---- name for DataWindow and indicator subwindow label   
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }
   string short_name;
   short_name="Z_MTF_RSI("+TimeFrame+","+RSIperiod+")";
    IndicatorShortName(short_name);     //    ("+TimeFrame+","+???????+","+???????+")";
     SetIndexLabel(0,short_name);
  }
//----
   return(0);
 
//+------------------------------------------------------------------+
//| MTF Parabolic Sar                                         |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i,limit,y=0,counted_bars=IndicatorCounted();

// Plot defined time frame on to current time frame
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   limit=Bars-counted_bars+TimeFrame/Period();
   //limit=Bars-counted_bars;
   if(counted_bars>0) limit++; else if (limit>100) limit=CountBars;  
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++;


   RSIBuffer[i]=iRSI(NULL,TimeFrame,RSIperiod,applied_price,y) ;
 {  
 
    if  ( RSI_Script )  
    {
       ObjectDelete("Line1");
       Line1( "Line1", 0, 0, 0);
       ObjectSetText( "Line1", "RSI", 12, "Arial Bold", DeepSkyBlue );
 }
       ObjectDelete("Line2");
       Line2( "Line2", 0, 0, 0);
       ObjectSetText("Line2",DoubleToStr(RSIBuffer[0],2),12,"Arial Bold",White);
     } 
     }  
     }
          int Line1( string Text, int xOffset, int yOffset,int iCorner) //LINE
   {  ObjectCreate(Text,OBJ_LABEL         , In_Window, 0, 0 );
      ObjectSet   (Text,OBJPROP_CORNER    , iCorner);
      ObjectSet   (Text,OBJPROP_XDISTANCE , 1100 );// 800
      ObjectSet   (Text,OBJPROP_YDISTANCE , 10 );
      ObjectSet   (Text,OBJPROP_BACK      , True );
   } 
   int Line2( string Text, int xOffset, int yOffset,int iCorner) 
   {  ObjectCreate(Text,OBJ_LABEL         , In_Window , 0, 0 );
      ObjectSet   (Text,OBJPROP_CORNER    , iCorner);
      ObjectSet   (Text,OBJPROP_XDISTANCE , 1150 );//850
      ObjectSet   (Text,OBJPROP_YDISTANCE , 10 );
      ObjectSet   (Text,OBJPROP_BACK      , True );
   } 
   
   
   return(0);
  
//+------------------------------------------------------------------+



